# rubocop:disable Style/ClassAndModuleChildren
class Setting::DefaultHostgroup < ::Setting
  # rubocop:enable Style/ClassAndModuleChildren
  BLANK_ATTRS << 'default_hostgroup'

  def self.load_defaults
    # Check the table exists
    return unless ActiveRecord::Base.connection.table_exists?('settings')
    return unless super

    Setting.transaction do
      [
        set('force_hostgroup_match', 'Apply hostgroup matching even if a host already has one.', false),
        set('force_hostgroup_match_only_new', 'Apply hostgroup matching only on new hosts', true),
        set('force_host_environment', "Apply hostgroup's environment to host even if a host already has a different one", true)
      ].compact.each do |s|
        attrs =
          s.update(category: 'Setting::DefaultHostgroup').reduce({}) do |r, (name, value)|
            self.new.respond_to?("#{name}=") ? r.merge(name => value) : r
          end

        self.where(name: attrs[:name]).first || self.create!(attrs)
      end
    end

    true
  end
end
